/* all to all */

#include <stdio.h>
#include <mmm/net_lib.h>
#include <mmm/io_lib.h>
#include <mmm/ionet_lib.h>

/* io_t prototyp for io-tasks reading and writing to socket */
io_t io_proto= proto_io	(	1,		/* prior */
				iof_in_out,	/* func */
				iouf_all_to_all,/* ufn */
				NULL,NULL	/* ptr, ptr2 */
			);

int main( void )
{ io_t *io;
  int r;
	if( (io=io_init(NULL))==NULL )	return(-1);
	if( (r=ionet_bind(io,&io_proto,3000))<0 )
	{	printf("Can't bind to port! error:%d\n",r);
		return(-1);
	}
	r=io_do(io);
	printf("EXIT: %d\n",r);
	io_final(io);
	return(0);
}

