/*  Print 				*/
/*  copyright (c)1997 by Marek Zelem	*/ 
/*  e-mail: marek@fornax.elf.stuba.sk	*/

#include <stdio.h>
#include <string.h>
#include <mmm/print.h>

char *print_num2sym( p_stab_t *stab, long num )
{ int i;
  static char buf[32];
	i=0;
	while( stab[i].name!=NULL )
	{	if( stab[i].num==num )
			return(stab[i].name);
		i++;
	}
	snprintf(buf,31,"%ld",num);
	buf[31]=0;
	return(buf);
}

char *print_num2orsym( p_stab_t *stab, unsigned long num )
{ int i,j,k;
  static char buf[1024];
	i=0;
	j=0;
	while( num>0 && stab[i].name!=NULL && j<1023 )
	{	if( stab[i].num & num )
		{	if( j>0 )	buf[j++]='|';
			k=0;
			while( j<1023 && (buf[j]=stab[i].name[k])!=0 )
			{	j++;	k++;	}
			num&=~(stab[i].num);
		}
		i++;
	}
	if( (num>0 && j<1023) || j==0 )
	{	if( j>0 && j<1023 )	buf[j++]='|';
		snprintf(buf+j,1023-j,"0x%lx",num);
		buf[1023]=0;
		j+=strlen(buf+j);
	}
	buf[j]=0;
	return(buf);
}

