/* pokus s elf- formatom */

#include <stdio.h>
#include <mmm/elf.h>

int main( int argc, char *argv[] )
{ elf_t *elf;
	if( argc!=2 )
	{	printf("usage: %s <obj.file>\n",argv[0]);
		return(0);
	}
	if( (elf=elf_open(argv[1]))==NULL )
	{	printf("Can't open file %s or not ELF format\n",argv[1]);
		return(-1);
	}
	if( elf_test(elf)<0 )
	{	printf("Bad version or machine!\n");
		elf_close(elf);
	}
	elf_print_elfhead(elf);
	elf_print_sections(elf);
	printf("Symbols:\n");
	elf_print_symbols(elf);
	printf("Reloc:\n");
	elf_print_reloc(elf);
	elf_close(elf);
	return(0);
}
