/* io_lib.c	  */
/* (c) by Marek Zelem */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>

/* load and unload files */

char *load_file( char *filename, long *len )
{ caddr_t mem;
  struct stat st;
  int fd;
	if( (fd=open(filename,O_RDONLY))<0 )	return(NULL);
	if( fstat(fd,&st)!=0 )	return(NULL);
	*len=st.st_size;
	if( (mem=mmap(0,*len,PROT_READ,MAP_PRIVATE|MAP_FILE,fd,0))==(caddr_t)(-1) )
	{	close(fd);	return(NULL);	}
/*
	{ if( (mem=malloc(*len))==NULL )	return(NULL);
	  if( read(fd,mem,*len)!=*len )	{ free(mem);	return(NULL); }
	}
*/
	close(fd);
	return((char*)mem);
}

int unload_file( char *mem, long len )
{
	if(mem==NULL)	return(0);
	return(munmap((caddr_t)mem,len));
}

