/* Wild compare
 * (c) by Marek Zelem
 */

#include <stdio.h>
#include <string.h>

#define	NWV	32

typedef struct { int wp;
		 int sp;
		 int s;
	       }  wildc_t;


int wild_one(char c,char *wild,int *wp)
{ int r;
  char w,p;
	r=2; p=0;
	while( r==2 )
	{ if( (w=wild[*wp])=='\\' )
	  {  (*wp)++;
	     if( (w=wild[*wp])==0 )	return(0);
	     else if( w==c )	r=1;
	  }
	  else if( w==']' || w==0 )	return(0);
	  else if( w=='-' )
	  { (*wp)++;
	    if( (w=wild[*wp])==']' || w==0 )	return(c>=p?1:0);
	    if( p<=c && c<=w )	r=1;
	  }
	  else if( w==c )	r=1;
	  (*wp)++;
	  p=w;
	}
	while( (w=wild[*wp])!=']' && w!=0 )	(*wp)++;
	return(r);
}

int wild_w(char *wild,char *str,int *wp,int *wz,int *sp )
{ int r,m,osp;
  char w;
	r=2; m=1; osp=*sp;
	while( r==2 )
	{
	if( (w=wild[*wp])==',' )
	{ *wz=*wp;
	  if( m )	r=1;
	  else	{ m=1; *sp=osp; (*wp)++; }
	}
	else if( w==')' || w==0 )	{ *wz=*wp; r=m; }
	else if( w=='\\' )
	{	(*wp)++;
		if( (w=wild[*wp])==0 )	r=0;
		else if( w!=str[*sp] )	{  m=0; (*wp)++; *sp=osp;	}
		else	{ (*wp)++; (*sp)++; }
	}
	else if( !m || w!=str[*sp] )
		{  m=0; (*wp)++; *sp=osp;	}
	else
		{ (*wp)++; (*sp)++; }
	}
	while( (w=wild[*wp])!=')' && w!=0 )	(*wp)++;
	if( wild[*wp]==')' )	(*wp)++;
	return(r);
}

int wildcmp(char *str,char *wild)
{ int r,m,pwp,psp;
  int wp,sp,s;
  wildc_t w[NWV];
  int v;

	s=0; v= -1;
	sp=wp=pwp=psp=0;
	r=1;

	while( r==1 && str[psp] && wild[pwp] )
	{

	psp=sp; pwp=wp;
	if( wild[wp]=='?' )
	{  if( str[sp] )
		{ wp++; sp++; }
	   else r=0;
	}
	else if( wild[wp]=='*' )
	{	wp++;
		if( !wild[wp] ) r=2;
		else
		{
		if( s!=1 )	v++;
		w[v].wp=wp; w[v].sp=sp;
		w[v].s=s;
		s=1;
		}
	}
	else if( wild[wp]=='[' )
	{	m=1; wp++;
		if( wild[wp]=='!' )	{ m=0; wp++; }
		if( wild_one(str[sp],wild,&wp) )
			r=m;
		else	r=(1-m);
		if(r==1)
		{ sp++; wp++; }
	}
	else if( wild[wp]=='(' )
	{	wp++;
		v++;
		w[v].wp=wp; w[v].sp=sp; w[v].s=s;
		if( wild[wp]=='!' )
		{	wp++;
			if(wild_w(wild,str,&wp,&(w[v].wp),&sp))	{ v--; r=0; }
			else { sp=w[v].sp; v--;	pwp=psp=0; }
		}
		else
		{	s=2;
			if( !wild_w(wild,str,&wp,&w[v].wp,&sp) )
			{ s=w[v].s; v--; r=0; }
			else { pwp=psp=0; }
		}
	}
	else if( wild[wp]=='\\' )
	{	wp++;
		if( !wild[wp] )		r=0;
		else if( wild[wp]!=str[sp] )		r=0;
		else { wp++; sp++; }
	}
	else if( wild[wp]!=str[sp] )
	{	r=0;	}
	else
	{	wp++; sp++;	}

	while( s>0 && r==0 )
	{	r=1; pwp=psp=0;
		if( s==2 )
		{	wp=w[v].wp+1; sp=w[v].sp;
			if( wild[w[v].wp]!=',' || !wild_w(wild,str,&wp,&(w[v].wp),&sp) )
			{	if(v>0)
				{ s=w[v].s; v--; wp=w[v].wp; sp=w[v].sp; r=0; }
				else	r= -1;
			}
		}
		else if( s==1 )
		{	wp=w[v].wp;
			if( !str[w[v].sp] )	r=0;
			(w[v].sp)++; sp=w[v].sp;
			if( r==0 || !str[sp] )
			{	if(v>0)
				{ s=w[v].s; v--; wp=w[v].wp; sp=w[v].sp; r=0; }
				else	r= -1;
			}
		}
	}

	}

	if( r>1 )	return(1);
	if( r<=0 || wild[pwp]!=0 )
		return(0);
	if( str[psp]==0 )
		return(1);
	return(0);

}

